#include <stdio.h>
#include <stdlib.h>
void main();
//Los metodos de en c se llaman desde ensamblador con un guión bajo "_"
void main() 
{
  __asm
    ld hl, #string ; en sdcc en los valores inmediatos hay que poner siempre la amohadilla
    call Print  ; Llama al método Print
    jr .        ; el punto (.) quiere decir la posición de la ram actual que se está ejecutando, es quiere decir que es un bucle infinito

    Print:
    ld  a,(hl)          ; Lee el 1 byte de la dirección de la memoria indicada y lo almacena en el registro a del z80.
    cp #0               ; Actualiza la bandera z del registro F del z80 y la pone un 1 si encuentra un 0.
    ret z               ; Devuelve el cotrol al Main si la bandera z del registro F del z80 es 0
    call #0x00A2        ; En sdcc los valores hexadecimales se expresan como en c, con 0x
                        ; Llama a la subrutina 00A2h de la Bios la cual imprime el caracter almacenado en el registro a del z80
    inc hl              ; incrementa el puntero de los registros hl para que señale al siguiente byte
    jr Print            ; Llama al métdo print para que lo vuelva a ejecutar
    
    string: .ascii "Hola mundo desde sdcc en .com con crt"
            .db 0  
  __endasm; 
}
